<?php
/* 
Plugin Name: WoW Guild Retrieve
Plugin URI: http://www.manatrance.com/
Description: Shows guild data for a World of Warcraft guild
Version: 0.9.7
Author: Ben Overmyer
Author URI: http://www.manatrance.com/
*/  

add_action('admin_menu', 'wow_guild_retrieve_options_menu');

wp_enqueue_script('newscript','/wp-content/plugins/wow-guild-retrieve/js/jquery.dataTables.min.js',array('jquery') );
wp_enqueue_style('wgrstyle','/wp-content/plugins/wow-guild-retrieve/css/wgr.css');

$style = get_option ( 'wgr_style' );

if ($style == 'light'){wp_enqueue_style('wgrlight','/wp-content/plugins/wow-guild-retrieve/css/wgr-light.css');}
if ($style == 'dark'){wp_enqueue_style('wgrdark','/wp-content/plugins/wow-guild-retrieve/css/wgr-dark.css');}

function wow_guild_retrieve_options_menu() {
	add_options_page('WoW Guild Retrieve Options', 'WoW Guild Retrieve', 8, __FILE__, 'WGR_options');
}

function WGR_options() {
	$var_realm = 'wgr_realm_name';
	$var_guild = 'wgr_guild_name';
	$var_region = 'wgr_region';
	$var_style = 'wgr_style';
	$var_sort = 'wgr_sort';
	$var_order = 'wgr_order';
	$var_restrict = 'wgr_restrict';
    $hidden_field_name = 'wgr_submit_hidden';
    $realm_field = 'wgr_realm_name';
	$guild_field = 'wgr_guild_name';
	$region_field = 'wgr_region';
	$style_field = 'wgr_style';
	$sort_field = 'wgr_sort';
	$order_field = 'wgr_order';
	$restrict_field = 'wgr_restrict';

    // Read in existing option value from database
    $realm_val = get_option( $var_realm );
	$guild_val = get_option( $var_guild );
	$region_val = get_option( $var_region );
	$style_val = get_option( $var_style );
	$sort_val = get_option( $var_sort );
	$order_val = get_option( $var_order );
	$restrict_val = get_option( $var_restrict );

    // See if the user has posted us some information
    // If they did, this hidden field will be set to 'Y'
    if( $_POST[ $hidden_field_name ] == 'Y' ) {
        // Read their posted value
		$realm_val = $_POST[ $realm_field ];
		$guild_val = $_POST[ $guild_field ];
		$region_val = $_POST[ $region_field ];
		$style_val = $_POST[ $style_field ];
		$sort_val = $_POST[ $sort_field ];
		$order_val = $_POST[ $order_field ];
		$restrict_val = $_POST[ $restrict_field ];

        // Save the posted value in the database
		update_option( $var_realm, $realm_val );
		update_option( $var_guild, $guild_val );
		update_option( $var_region, $region_val );
		update_option( $var_style, $style_val );
		update_option( $var_sort, $sort_val );
		update_option( $var_order, $order_val );
		update_option( $var_restrict, $restrict_val );

        // Put an options updated message on the screen

?>
<div class="updated"><p><strong><?php _e('Options saved.', 'wgr_trans_domain' ); ?></strong></p></div>
<?php

    }

    // Now display the options editing screen

    echo '<div class="wrap">';

    // header

    echo "<h2>" . __( 'WoW Guild Retrieve Plugin Options', 'wgr_trans_domain' ) . "</h2>";

    // options form
    
    ?>

<form name="form1" method="post" action="<?php echo str_replace( '%7E', '~', $_SERVER['REQUEST_URI']); ?>">
<input type="hidden" name="<?php echo $hidden_field_name; ?>" value="Y">

<p><?php _e("Realm Name:", 'wgr_trans_domain' ); ?> 
<input type="text" name="<?php echo $realm_field; ?>" value="<?php echo $realm_val; ?>" size="20">
</p>

<p><?php _e("Guild Name:", 'wgr_trans_domain' ); ?> 
<input type="text" name="<?php echo $guild_field; ?>" value="<?php echo $guild_val; ?>" size="20">
</p>

<p><?php _e("Region:", 'wgr_trans_domain' ); ?>
<select name="<?php echo $region_field; ?>">
	<option name="us" value="us" <?php if ($region_val == 'us') { echo 'selected="selected"';} ?>>us</option>
	<option name="eu" value="eu" <?php if ($region_val == 'eu') { echo 'selected="selected"';} ?>>eu</option>
</select>
</p>

<p><?php _e("Style:", 'wgr_trans_domain' ); ?>
<select name="<?php echo $style_field; ?>">
	<option name="dark" value="dark" <?php if ($style_val == 'dark') { echo 'selected="selected"';} ?>>Dark</option>
	<option name="light" value="light" <?php if ($style_val == 'light') { echo 'selected="selected"';} ?>>Light</option>
</select>
</p>

<p><?php _e("Default Sort:", 'wgr_trans_domain' ); ?>
<select name="<?php echo $sort_field; ?>">
	<option name="sort-rank" value="4" <?php if ($sort_val == 4) { echo 'selected="selected"';} ?>>Rank</option>
	<option name="sort-name" value="0" <?php if ($sort_val == 0) { echo 'selected="selected"';} ?>>Name</option>
	<option name="sort-race" value="1" <?php if ($sort_val == 1) { echo 'selected="selected"';} ?>>Race</option>
	<option name="sort-class" value="2" <?php if ($sort_val == 2) { echo 'selected="selected"';} ?>>Class</option>
	<option name="sort-level" value="3" <?php if ($sort_val == 3) { echo 'selected="selected"';} ?>>Level</option>
</select>
</p>

<p><?php _e("Sort Order:", 'wgr_trans_domain' ); ?>
<select name="<?php echo $order_field; ?>">
	<option name="sort-asc" value="asc" <?php if ($order_val == 'asc') { echo 'selected="selected"';} ?>>Ascending</option>
	<option name="sort-desc" value="desc" <?php if ($order_val == 'desc') { echo 'selected="selected"';} ?>>Descending</option>
</select>
</p>

<p><?php _e("Restrict to 80:", 'wgr_trans_domain' ); ?>
<select name="<?php echo $restrict_field; ?>">
	<option name="no" value="no" <?php if ($restrict_val == 'no') { echo 'selected="selected"';} ?>>No</option>
	<option name="yes" value="yes" <?php if ($restrict_val == 'yes') { echo 'selected="selected"';} ?>>Yes</option>
</select>
</p>

<hr />

<p class="submit">
<input type="submit" name="Submit" value="<?php _e('Update Options', 'wgr_trans_domain' ) ?>" />
</p>

</form>
</div>

<?php

}

function buildURL($guild,$realm,$region) {
	$url = "";
	
	$guild = str_replace(' ','+',$guild);
	$realm = str_replace(' ','+',$realm);
	
	if ($region == 'us') {
		$url = 'http://www.wowarmory.com/guild-info.xml';
	} else {
		$url = 'http://eu.wowarmory.com/guild-info.xml';
	}
	
	$url .= '?r=' . stripslashes($realm) . '&n=' . $guild . '&p=1';
	
	return $url;
}

function wow_guild_retrieve() {
	$guild_name = get_option( 'wgr_guild_name' );
	$realm_name = get_option( 'wgr_realm_name' );
	$region = get_option ( 'wgr_region' );
	$sorttype = get_option ( 'wgr_sort' );
	$sortorder = get_option ( 'wgr_order' );
	$restrict = get_option ( 'wgr_restrict' );
	
    $url = buildURL($guild_name,$realm_name,$region);

	$ch = curl_init($url);
	
	curl_setopt($ch, CURLOPT_USERAGENT, "Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.8.1.3) Gecko/20070309 Firefox/2.0.0.3");
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
	$output = curl_exec($ch);
	curl_close($ch);

	$parser = xml_parser_create();
	xml_parse_into_struct($parser, $output,$vals,$index);
	xml_parser_free($parser);

	if (!$index) {
		echo "Unable to contact Armory.";
	} else {
		echo '<script type="text/javascript">';
		echo 'jQuery(document).ready(function() ';
		echo '{'; 
        echo 'jQuery("#guildinfo").dataTable({';
		echo '"aaSorting": [[' . $sorttype . ',"' . $sortorder . '"]]';
		echo '});';
		echo '}'; 
		echo ');';
		echo '</script>';
		echo '<div id="guild-data-div">';
		echo '<div id="header-block">';
		
		$ginfo_index = $index["GUILDHEADER"]["0"];
		$ginfo = $vals[$ginfo_index]["attributes"];	
		$gname = $ginfo["NAME"];
		$gfaction = $ginfo["FACTION"];
		$minfo_index = $index["MEMBERS"]["0"];
		$minfo = $vals[$minfo_index]["attributes"];
		$gmembers = $minfo["MEMBERCOUNT"];
		
		echo '<img src="/wp-content/plugins/wow-guild-retrieve/images/faction-' . $gfaction . '.png" alt="" height="64" width="64"/>';
		echo '<div id="header-text">';
		echo '<h2>' . $gname . '</h2>';
		echo '<h3>' . $gmembers . ' members</h3>';
		echo '</div>';
		echo '<div class="clear"></div>';
		echo '</div>';
		echo "<table id='guildinfo'>\n";
		echo "<thead><tr><th class='ginfo-name'>Name</th><th class='ginfo-race'>Race</th><th class='ginfo-class'>Class</th><th class='ginfo-level'>Level</th><th class='ginfo-rank'>Rank</th></tr></thead>\n";
		echo "<tbody>\n";
		
		$whichrow = 0;
		
		foreach($index["CHARACTER"] as $characters) {
			$character = $vals[$characters]["attributes"];
			$raceid = $character["RACEID"];
			if ($raceid == '0') { $race = "Zero";
			} elseif ($raceid == '1') { $race = "Human";
			} elseif ($raceid == '2') { $race = "Orc";
			} elseif ($raceid == '3') { $race = "Dwarf";
			} elseif ($raceid == '4') { $race = "NightElf";
			} elseif ($raceid == '5') { $race = "Undead";
			} elseif ($raceid == '6') { $race = "Tauren";
			} elseif ($raceid == '7') { $race = "Gnome";
			} elseif ($raceid == '8') { $race = "Troll";
			} elseif ($raceid == '9') { $race = "Nine"; 
			} elseif ($raceid == '10') { $race = "BloodElf";
			} elseif ($raceid == '11') { $race = "Draenei";
			} else { $race = "Bork"; }
			
			$genderid = $character["GENDERID"];
			if ($genderid == '0') { $gender = "Male"; } else { $gender = "Female"; }
			
			$classid = $character["CLASSID"];
			if ($classid == '0') { $class = "Zero";
			} elseif ($classid == '1') { $class = "Warrior";
			} elseif ($classid == '2') { $class = "Paladin";
			} elseif ($classid == '3') { $class = "Hunter";
			} elseif ($classid == '4') { $class = "Rogue";
			} elseif ($classid == '5') { $class = "Priest";
			} elseif ($classid == '6') { $class = "DeathKnight";
			} elseif ($classid == '7') { $class = "Shaman";
			} elseif ($classid == '8') { $class = "Mage";
			} elseif ($classid == '9') { $class = "Warlock";
			} elseif ($classid == '10') { $class = "Ten";
			} elseif ($classid == '11') { $class = "Druid";
			} else { $class = "Bork"; }
			
			$raceimg = 'race-' . $race . '-' . $gender . '.png';
			$classimg = 'class-' . $class . '.png';
			if ($character["RANKID"] == '0') { $rank = "Guild Leader"; } else { $rank = "Rank " . $character["RANK"]; }
			
			if (($restrict == 'yes' AND $character["LEVEL"] == '80') OR ($restrict == 'no')){
				if ($whichrow == 0) {
					$rowstyle = "odd";
				} else {
					$rowstyle = "even";
				}
				echo "<tr class='$rowstyle'>";
				echo "<td class='ginfo-name'><a href='http://" . $region . ".wowarmory.com/character-sheet.xml?" . $character["URL"] . "'>" . $character["NAME"] . "</a></td><td class='ginfo-race'><img src='/wp-content/plugins/wow-guild-retrieve/images/" . $raceimg . "' alt='" . $race . "' width='32' height='32'/></td><td class='ginfo-class'><img src='/wp-content/plugins/wow-guild-retrieve/images/" . $classimg . "' alt='" . $class . "' width='32' height='32'/></td><td class='ginfo-level'>" . $character["LEVEL"] . "</td><td class='ginfo-rank'>" . $rank . "</td></tr>";
				echo "</tr>\n";
				$whichrow++;
				if ($whichrow >= 2) {
					$whichrow = 0;
				}
			}
		}
		echo "</tbody>";
		echo "</table>";
		echo "<div class='clear'></div>";
		echo "</div>";
	
	}
}

function check_guild($the_content) {
	
	$mystring = "get_guild_info";
	
	$pos = strpos($the_content, $mystring);
	
	if ($pos !== FALSE) {
		wow_guild_retrieve();
		$the_content = str_replace('get_guild_info','',$the_content);
	}
	
	return $the_content;
}

add_filter('the_content', 'check_guild');

?>